/**
* 
* Package:     @virtualpatterns/babel-plugin-mablung-replace-string-literal
* Description: TBD
* Version:     0.0.3
* License:     GPL-3.0+
* Author:      virtualpatterns.com <code@virtualpatterns.com> (http://www.virtualpatterns.com)
* Repository:  https://github.com/virtualpatterns/babel-plugin-mablung-replace-string-literal
* Source:      source/library/visitor.cjs
* 
**/
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Visitor = void 0;

var _visitor = require("@virtualpatterns/babel-plugin-mablung/visitor");

var _is = _interopRequireDefault(require("@pwn/is"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Visitor extends _visitor.Visitor {
  constructor(babel) {
    super(babel);
  }

  get nodeType() {
    return ['StringLiteral'];
  }

  onStringLiteralNode(path, state) {
    // console.log(`Visitor.onStringLiteralNode('${path.node.name}', state)`)
    let option = state.opts;
    let rule = option.rule;
    rule.forEach(rule => {
      rule.searchForPattern = rule.searchForPattern ? rule.searchForPattern : _is.default.regexp(rule.searchFor) ? rule.searchFor : new RegExp(rule.searchFor, 'gi');
      path.node.value = path.node.value.replace(rule.searchForPattern, rule.replaceWith);
    });
  }

} // {
//   'rule': [
//     {
//       'searchFor': '../error/replace-error.js',
//       'replaceWith': '...',
//     }
//   ]
// }      


exports.Visitor = Visitor;
